/* eslint-disable import/no-extraneous-dependencies */
import React from 'react';
import { storiesOf } from '@storybook/react';
import { withInfo } from '@storybook/addon-info';
import { withNotes } from '@storybook/addon-notes';
import * as knobs from '@storybook/addon-knobs/react';
import ScrollToTop from '../ScrollToTop';
import defaultNotes from './ScrollToTop.md';
import './ScrollToTop.scss';

const stories = storiesOf('ScrollToTop', module);

stories.addDecorator(knobs.withKnobs);
stories.addDecorator(story => (
  <div>
    {story()}
    <div style={{ width: '100%', height: '1500px', padding: '40px 200px' }}>
      <p>long content here...</p>
      <p>long content here...</p>
      <p>long content here...</p>
      <p>long content here...</p>
      <p>long content here...</p>
      <p>long content here...</p>
      <p>long content here...</p>
      <p>long content here...</p>
      <p>long content here...</p>
      <p>long content here...</p>
      <p>long content here...</p>
      <p>scroll down...</p>
    </div>
  </div>
));

stories.add(
  'ScrollToTop',
  withNotes(defaultNotes)(
    withInfo()(() => {
      return <ScrollToTop />;
    })
  )
);

stories.add(
  'ScrollToTop - showOffset',
  withNotes(defaultNotes)(
    withInfo()(() => {
      return <ScrollToTop showOffset={100} />;
    })
  )
);

stories.add(
  'ScrollToTop - custom children',
  withNotes(defaultNotes)(
    withInfo()(() => {
      return (
        <ScrollToTop>
          <button
            style={{
              position: 'fixed',
              top: 100,
              left: 100,
              cursor: 'pointer',
            }}
          >
            click me to scroll to top
          </button>
        </ScrollToTop>
      );
    })
  )
);
